###################################################################################################
##########                          EXAMPLE: SPECIAL CHARACTERS                          ##########
###################################################################################################

print("This string\n\n\n\nHas a bunch of newlines in the middle of it!")

print("==========================================================================================")

print("This string\tHas a tab in the middle of it.")
print("Tabs might\tbe different lengths depending on where they appear in the string.")

print("==========================================================================================")

print('This string says "I have a quote in me!"')
print("This string says \"I have a quote in me!\"")
print("This string says \"I'm an annoyingly complicated example to prove a point!\"")

print("==========================================================================================")
print("This string \\ just has a backslash in it for some reason. Not two backslashes though!")


###################################################################################################
##########                             EXERCISE: FLASH CARDS                             ##########
###################################################################################################
# Update this code such that the formatting is more flexible 
# (e.g., "TRES", "tres  ", etc. would be accepted)?
###################################################################################################


translations = {"one": "uno", "two": "dos", "three": "tres"}
correct = set()

# keep going if not all correct
while len(correct) != len(translations):
    # not_correct is the set of words that haven't been guessed correctly
    not_correct = set(translations.keys()) - correct

    for word in not_correct: 
        # user should guess all incorrect words
        user_trans = input("Translate " + word + " to spanish: ")
        if user_trans == translations[word]:
            correct.add(word)
            print("Good job!")
        else:
            print("Not quite!")


###################################################################################################
##########                         EXAMPLE: READING TRANSLATIONS                         ##########
###################################################################################################

f = open("translations.txt", "r")
translations = {}
for line in f:
    split_message = line.split()
    english = split_message[0]
    spanish = split_message[1]
    translations[english] = spanish
f.close()
print(translations)

###################################################################################################
##########                      EXERCISE: READING AND WRITING GRADES                     ##########
###################################################################################################
# Update this code such that the formatting is more flexible 
# (e.g., "TRES", "tres  ", etc. would be accepted)?
###################################################################################################
def drop_lowest_grade(filename_in, filename_out):
    f_in = open(filename_in, "r")
    grades = []
    for line in f_in:
        grades.append(int(line))
    f_in.close()
    f_out = open(filename_out, "w")
    for grade in grades:
        if grade != min(grades):
            f_out.write(grade)
    f_out.close()


drop_lowest_grade("grades.txt", "grades_dropped.txt")


###################################################################################################
##########                               EXERCISE: COPYING                               ##########
###################################################################################################
x = [1, 2, [3]]
y = x.copy()
x[-1][0] = 4
print(y)

###################################################################################################
##########                             EXERCISE: REFERENCES                              ##########
###################################################################################################
x = [1, 3, 4]
y = x
y.append(4)
x[0] = 10
print(x)
print(y)